Attribute VB_Name = "Modul_AutoRng"
Option Explicit
'Das Programm wurde von einem Forenmitglied im VBA-Forum.de berarbeitet und lauffhig gemacht! Vielen Dank!

Sub AutoRange_Export()        'Das Modul_AutoRng muss auf dem ersten Feldnamen (hier Standort) _
'                                 gestartet werden. Der nach der Vorlage (siehe Blatt ANLEITUNG) _
'                                 erkannte Zellbereich wird als Bereich erkannt und in eine _
'                                 Semikolongetrennte *.CSV-Datei gespeichert
    Dim ws As Worksheet
    Dim wb As Workbook
    Dim WorkRng As Range            'fr Zellbereich aus Kopfzeilen + Datenzellen
    Dim Worksheetx As Variant
    Dim strErr As String
    Dim lngDauer As Variant         'Ist die letzte zeile eine Datenzelle (Inhalt vorhanden)
    Dim ErrorFlag As Boolean
    Dim ErrorFlag2 As Boolean
    Dim AzBuecher&
    Dim NameExtension As Variant
    Dim NameAnhang As String
    Dim csvName As String
    Dim csvSub As Variant
    Dim csvDir As Variant
    
    Dim FlagExt As Variant
                                               ' +++ Defaultwerte
    csvSub = "\CSV-Listen fuer BOOKcook Import\"    'Unterverzeichnis fr *.CSV Dateien                                                                "
    csvName = "CSV-Transfer"                        ' Dateiname fr CSV-Datei
    lngDauer = 5                                    ' MsgBox Anzeigedauer in Sekunden
    FlagExt = "1"                                   ' Defaultwert >=1 wird ausgewertet
       
    ''''  On Error Resume Next
    Set WorkRng = ActiveCell
    
    Call auto_range(ActiveSheet.Name, ErrorFlag, ErrorFlag2, strErr, WorkRng, AzBuecher, NameExtension, FlagExt)
                                                                                'gltiger Zellbereich ermitteln
    If ErrorFlag2 = True Then GoTo Abbruch  'MsgBox in sub auto_range
    If ErrorFlag = True Then GoTo Fehler
    
    Set wb = Workbooks.Add                                 'Kopie des Arbeitsblattes in Mappe_xxx
    wb.Worksheets(1).Name = WorkRng.Worksheet.Name
    WorkRng.Copy Destination:=wb.Worksheets(1).Range("A1") 'Kopiert "Bereich/Range" ab A1 in Mappe_n
                                       
    Application.DisplayAlerts = False                         'WarnMeldung wenn berschreiben ? AUS
                                                              
    csvDir = ThisWorkbook.Path & csvSub       'komplette Adresse des Unterverzeichnisses
     
    If Dir(csvDir, vbDirectory) = "" Then     'Prfen ob Verzeichnniss vorhanden, sonst erstellen
        MkDir (csvDir)
        MsgBox "Das Verzeichnis  " & (csvSub) & "  wurde erstellt!", vbInformation
    End If
        
    wb.SaveAs Filename:=csvDir & csvName & NameExtension, _
                            FileFormat:=xlCSV, _
                            CreateBackup:=False, _
                            Local:=True             'Speichert im Pfad der Exceldatei
    wb.Close True
    Application.DisplayAlerts = True                            'WarnMeldung berschreiben ? Ein
    
    Call MessageBox_zeitgesteuert(csvName, NameExtension, NameAnhang, lngDauer, AzBuecher)
    
Exit Sub
Fehler:
  MsgBox "Keine Datei erstellt." & vbLf & strErr, vbCritical, "ein Fehler ist aufgetreten"
Abbruch:
End Sub

Sub auto_range(Worksheetx As String, ErrorFlag As Boolean, ErrorFlag2 As Boolean, sErr As String, _
WorkRng As Range, lngAzB As Long, NameAnhang, FlagExt)
                                                                           'Datensatz auf Gltigkeit prfen
    Dim MaxBuecher&, i&, LastRow&, FirstRow&
    Dim VorlFeldnamen As Variant
    Dim checkrange As Range
    Dim StartZelle As Variant
    Dim ValueLetzteSpalte As Variant
    Dim NameAnhang2 As String
                                                        'Vorlagen Feldnamen in Datenfeld speichern
    VorlFeldnamen = Application.Transpose(Application.Transpose(Range(Range("Kopfz_S"), _
                                                                            Range("Kopfz_6").End(xlToLeft))))
    MaxBuecher = Range("MaxBuecher").Value           'Maximale Anzahl Datenzeilen speichern Zelle aktivieren
    FlagExt = Range("okExtension").Value             ' Dateinamen Erweiterung X=ein "" = AUS
    StartZelle = Range("Kopfz_S").Value
           
'***************** Prfen ob Starzelle  = 1. Kopfzelle

    If ActiveCell.Value <> VorlFeldnamen(1) Then
        ErrorFlag2 = True
        MsgBox (" Bitte den ersten Feldnamen  ") & StartZelle & ("  whlen! "), vbInformation
        GoTo Brexit
    End If
    
    NameAnhang = ActiveCell.Offset(1, 0).Value                 ' Inhalt der DateinamenErweiterung
    
'***************** Prfen ob die Kopfzeile der Vorgabe aus "ANLEITUNG" entspricht *************
    
   Set checkrange = ActiveCell
   For i = LBound(VorlFeldnamen) To UBound(VorlFeldnamen)
    If checkrange.Offset(, -1 + i).Value <> VorlFeldnamen(i) Or checkrange.Offset(, -1 + i).Value = "" Then
        ErrorFlag = True
        MsgBox (" Kopfzeilen stimmen nicht berein !"), vbCritical
        GoTo Brexit
        End If
   Next
  '---------------
    If i <= UBound(VorlFeldnamen) Then
      sErr = "Feldnamen stimmen nicht berein - Siehe Blatt Anleitung!!"
      ErrorFlag = True
      Exit Sub
    End If
              
    LastRow = checkrange.End(xlDown).Row
    lngAzB = LastRow - checkrange.Row
   
    If FlagExt >= 1 Then
    NameAnhang = "-ab_" + NameAnhang + " bis " + checkrange.Offset(lngAzB).Value        'Namens Erweiterung
    Else
    NameAnhang = ""
    End If
      
    If lngAzB > MaxBuecher Then
       ErrorFlag = True
       sErr = lngAzB & " Bcher sind zu viel." & vbLf & "Es sind nur " & MaxBuecher & " im Fach vorgesehen"
       Exit Sub
    End If
    
    'ndert die Gre des angegebenen Bereichs
    Set WorkRng = checkrange.Resize(lngAzB + 1, UBound(VorlFeldnamen))
Brexit:
End Sub

Private Sub MessageBox_zeitgesteuert(csvName, NameAnhang, NameAnhang2, lngDauer, AzBuecher)
                                                            'Beendet die Windows "MessageBox" nach lngDauer
Dim iAnzeige As Integer
Dim objShell As Object
Set objShell = CreateObject("WScript.Shell")
iAnzeige = objShell.Popup("In der neuen Datei  " & csvName & NameAnhang & NameAnhang2 & ".CSV  wurden " & AzBuecher & _
" Bcher gespeichert", _
  lngDauer, "CSV fr BOOKcook Import                                    Anzeigedauer: " & lngDauer _
  & " sec.", vbInformation)
End Sub

